@echo off

echo.
setlocal enabledelayedexpansion
set OPLAN_PATH=%cd%\oplan.bat
set OPLAN_JARS=%cd%\jlib\oracle.oplan.classpath.jar

if "%ORACLE_HOME%"=="" (
    echo Please set the ORACLE_HOME environment variable to the location of the Grid Infrastructure ^(GI^) Home
    goto:eof
)

set JAVA=%ORACLE_HOME%\jdk\bin\java.exe
if not exist %JAVA% (
    if "%JAVA_HOME%"=="" (
        echo Please set the JAVA_HOME environment variable to the location of the Java Home
        goto:eof
    ) else (
        set JAVA=%JAVA_HOME%\bin\java.exe
        if not exist !jAVA! (
            echo Could not find !JAVA!
            goto:eof
        )
    )
)

    
:set_opatch_env_vars
    set cp=%ORACLE_HOME%\OPatch\jlib
    set OPATCH_JARS=%CP%\oracle.opatch.classpath.jar
    if not exist %OPATCH_JARS% ( 
        set cp=%ORACLE_HOME%\..\opatch\OPatch\jlib
        set OPATCH_JARS=!CP!\oracle.opatch.classpath.jar
    )
    if "%CLASS_PATH%"=="" (
        set CLASS_PATH=%OPATCH_JARS% 
    ) else (
        set CLASS_PATH=%OPATCH_JARS%;%CLASS_PATH%
    )

:set_oui_env_vars
    set cp=%ORACLE_HOME%\oui\jlib
    set OUI_JARS=%CP%\OraInstaller.jar;%CP%\OraPrereq.jar;%CP%\share.jar;%CP%\orai18n-mapping.jar;%CP%\xmlparserv2.jar
    set CLASS_PATH=%OUI_JARS%;%CLASS_PATH%
    
    if  "%JRE_MEMORY_OPTIONS%"=="" (
        if exist "%ORACLE_HOME%\oui\oraparam.ini" (
            for /f "delims== tokens=2" %%i in ( 'findstr "JRE_MEMORY_OPTIONS=" %ORACLE_HOME%\oui\oraparam.ini' ) do set JRE_MEMORY_OPTIONS=%%i
            if not "!JRE_MEMORY_OPTIONS!"=="" set JRE_MEMORY_OPTIONS=!JRE_MEMORY_OPTIONS:"=!
        )
    )

:set_srvm_env_vars
    set SP=%ORACLE_HOME%\jlib
    set SRVM_CLASS_PATH=%SP%\srvm.jar;%SP%\srvmasm.jar;%SP%\srvmhas.jar
    set CLASS_PATH=%SRVM_CLASS_PATH%;%CLASS_PATH%

set "CMD="%JAVA%" %JRE_OPTIONS% %JRE_MEMORY_OPTIONS% -cp %OPLAN_JARS%;%CLASS_PATH% oracle/opatch/oplan/oplan/OPlan -XOPlanLocation=%OPLAN_PATH% -XUserInvokingOplan=%USERNAME% %*%"
%CMD%

